#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long LL;

int main() {
	int n;
	scanf("%d", &n);

	struct Car {
		int t;
		int dir;
		int id;

		bool operator<(const Car &c) const {
			return t != c.t ? t < c.t : dir < c.dir;
		}
	};

	vector<Car> c(n);
	for (int i = 0; i < n; ++i) {
		char tmp;
		scanf("%d %c", &c[i].t, &tmp);
		if (tmp == 'U') c[i].dir = 3;
		if (tmp == 'R') c[i].dir = 2;
		if (tmp == 'D') c[i].dir = 1;
		if (tmp == 'L') c[i].dir = 0;
		c[i].id = i;
	}

	sort(c.begin(), c.end());

	vector<int> ans(n, -1);

	int t = 0;

	int it = 0;

	queue<int> q[4];
	int sz = 0;
	while (it < n) {
		while (it < n && c[it].t == t) {
			q[c[it].dir].push(c[it].id);
			it++;
			sz++;
		}
		vector<bool> can(4);
		for (int i = 0; i < 4; ++i) {
			if (q[i].size() && q[(i + 1) % 4].empty()) can[i] = 1;
        }

		if (!can[0] && !can[1] && !can[2] && !can[3] && sz) {
			break;
		}

		bool any = 0;

		for (int i = 0; i < 4; ++i) {
			if (can[i]) {
				int f = q[i].front();
				q[i].pop();
				any = 1;

				sz--;
				ans[f] = t;
			}
		}

		if (any) t++;
		else if (it < n) t = c[it].t;
	}

	for (int i = 0; i < n; ++i) {
		printf("%d\n", ans[i]);
	}


	return 0;
}