#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long LL;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int nf, mf;
	cin >> nf >> mf;

	vector<string> f(nf);

	for (int i = 0; i < nf; ++i)
		cin >> f[i];

	int nt, mt;
	cin >> nt >> mt;

	vector<string> t(nt);

	for (int i = 0; i < nt; ++i) {
		cin >> t[i];
	}

	vector<int> def_posf(mf, (int)1e9), def_post(mt, (int)-1e9);

	for (int i = 0; i < nf; ++i) {
		for (int j = 0; j < mf; ++j) {
			if (f[i][j] == '*') def_posf[j] = min(def_posf[j], nf - i - 1);
		}
	}

	for (int i = 0; i < nt; ++i) {
		for (int j = 0; j < mt; ++j) {
			if (t[i][j] == '#') def_post[j] = max(def_post[j], -i);
		}
	}

	int ans = 0;

	for (int ms = -min(mt, mf) + 1; ms < min(mt, mf); ++ms) {
		if (mf + ms < 0 || ms >= mt) continue;
		int dx = (int)1e9;

		for (int j = max(0, ms); j < min(mf+ms, min(mf, mt)); ++j) {
			int kek = j - ms;

			dx = min(dx, def_posf[kek] - def_post[j]);
		}
		//cout << ms << ' ' << dx << endl;

		vector<string> tmp(nt+nf+10, string(max(mt, mf) + 13, '.'));

		for (int j = 0; j < nt; ++j) {
			for (int k = 0; k < mt; ++k) {
				tmp[j+nf+5][k + 5] = t[j][k];
			}
		}

		for (int j = max(-1, ms); j < min(mf + ms + 1, min(mf + 1, mt)); ++j) {
			int kek = j - ms;

			//def_posf[kek]

			for (int k = 0; k < nf; ++k) {
				int ny = j, nx = +dx + k - nf;
				if (f[k][kek] == '*' && kek >= 0 && kek < mt + 3)
					tmp[nx + nf + 5][ny + 5] = '*';
			}
		}
        
		int cur = 0;
		for (int i = 0; i < tmp.size(); ++i) {
			for (int j = 0; j < tmp[i].size() - 1; ++j) {
				if (tmp[i][j] == '#' && tmp[i][j + 1] == '*') cur++;
			}
		}

		if (ans < cur) {
			ans = cur;
		}
        
	}

	cout << ans << endl;

	return 0;
}