#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<int>> al;
vector<bool> used;
vector<int> ts;

void dfs(int u) {
	used[u] = true;
	for (int v : al[u]) {
		if (!used[v]) {
			dfs(v);
		}
	}
	ts.push_back(u);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	al.resize(n);
	used.resize(n);
	vector<pair<int, int>> edges;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		edges.push_back({ x, y });
		al[x].push_back(y);
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	vector<bool> ok(n - 1);
	vector<int> ind(n);
	for (int i = 0; i < n; i++) {
		ind[ts[i]] = i;
	}

	int bad = n - 1;
	int cur = 0;
	for (auto e : edges) {
		cur++;
		int u = ind[e.first];
		int v = ind[e.second];
		if (v < u) {
			swap(u, v);
		}
		if (v == u + 1 && !ok[u]) {
			ok[u] = true;
			bad--;
			if (bad == 0) {
				cout << cur << endl;
				return 0;
			}
		}
	}

	cout << -1 << endl;

	return 0;
}