#include <iostream>
#include <vector>
#include <cmath>
#include <windows.h>

class Driver
{
public:
  INT64 time;
  INT64 num;

  Driver( INT64 t, INT64 num )
  {
    time = t; 
    this->num = num;
  }
};

void main( void )
{
  std::vector<Driver> Up, Left, Down, Right;

  int n;

  scanf("%i", &n);

  INT64 *out = new INT64[n];
  for (int i = 0; i < n; i++)
    out[i] = -1;

  for (int i = 0; i < n; i++)
  {
    INT64 t;
    char d;

    scanf("%I64d %c", &t, &d);
    if (d == 'R')
      Left.push_back(Driver(t, i));
    else if (d == 'L')
      Right.push_back(Driver(t, i));
    else if (d == 'U')
      Down.push_back(Driver(t, i));
    else if (d == 'D')
      Up.push_back(Driver(t, i));
  }

  INT64 tfull = 0;
  bool flagU = 0, flagD = 0, flagR = 0, flagL = 0;
  while (Up.size() != 0 || Down.size() != 0 || Left.size() != 0 || Right.size() != 0)
  {
    flagU = 0, flagD = 0, flagR = 0, flagL = 0;
    if (!Up.empty() && Up[0].time == 0 && (Left.empty() || Left[0].time != 0))
    {
      out[Up[0].num] = tfull;
      flagU = 1;
    }
    if (!Right.empty() && Right[0].time == 0 && (Up.empty() || Up[0].time != 0))
    {
      out[Right[0].num] = tfull;
      flagR = 1;
    }
    if (!Left.empty() && Left[0].time == 0 && (Down.empty() || Down[0].time != 0))
    {
      out[Left[0].num] = tfull;
      flagL = 1;
    }
    if (!Down.empty() && Down[0].time == 0 && (Right.empty() || Right[0].time != 0))
    {
      out[Down[0].num] = tfull;
      flagD = 1;
    }
    if (flagR)
      Right.erase(Right.begin());
    if (flagU)
      Up.erase(Up.begin());
    if (flagD)
      Down.erase(Down.begin());
    if (flagL)
      Left.erase(Left.begin());

    for (int i = 0; i < Up.size(); i++)
    {
      if (flagU)
        Up[i].time--;
      else if (i == 0 && Up[0].time != 0)
        Up[0].time--;
      else if (i != 0)
        if (abs(Up[i - 1].time - Up[i].time) > 1)
          Up[i].time--;
    }

    for (int i = 0; i < Down.size(); i++)
    {
      if (flagD)
        Down[i].time--;
      else if (i == 0 && Down[0].time != 0)
        Down[0].time--;
      else if (i != 0)
        if (abs(Down[i - 1].time - Down[i].time) > 1)
          Down[i].time--;
    }

    for (int i = 0; i < Left.size(); i++)
    {
      if (flagL)
        Left[i].time--;
      else if (i == 0 && Left[0].time != 0)
        Left[0].time--;
      else if (i != 0)
        if (abs(Left[i - 1].time - Left[i].time) > 1)
          Left[i].time--;
    }

    for (int i = 0; i < Right.size(); i++)
    {
      if (flagR)
        Right[i].time--;
      else if (i == 0 && Right[0].time != 0)
        Right[0].time--;
      else if (i != 0)
        if (abs(Right[i - 1].time - Right[i].time) > 1)
          Right[i].time--;
    }

    if (!Up.empty() && Up[0].time == 0 && !Down.empty() && Down[0].time == 0 && !Left.empty() && Left[0].time == 0 && !Right.empty() && Right[0].time == 0)
      break;
    tfull++;
  }

  for (int i = 0; i < n; i++)
    printf("%I64d\n", out[i]);
}