import java.io.*;
import java.util.*;

public class I {
	
	public static class Pair {
		int x;
		int y;
		
		public Pair(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}
	
	public static void dfs(int i) {
		used[i] = true;
		for (int x : h[i]) {
			if (!used[x]) {
				dfs(x);
			}
		}
		a.add(i);
	}
	
	static HashSet<Integer>[] h;
	static ArrayList<Integer> a;
	static boolean[] used;
   
    public void solve() throws IOException {
       int n = nextInt();
       int m = nextInt();
       Pair[] p = new Pair[m];
       used = new boolean[n];
       for (int i = 0; i < m; i++) {
    	   p[i] = new Pair(nextInt() - 1, nextInt() - 1);
       }
       int l = n - 2;
       int r = m + 1;
       while (l + 1 < r) {
    	   int med = (l + r) / 2;
    	   h = new HashSet[n];
    	   for (int i = 0; i < used.length; i++) {
    		   used[i] = false;
    	   }
    	   a = new ArrayList<>();
    	   for (int i = 0; i < h.length; i++) {
    		   h[i] = new HashSet<>();
    	   }
    	   for (int i = 0; i < med; i++) {
    		   h[p[i].x].add(p[i].y);
    	   }
    	   for (int i = 0; i < n; i++) {
    		   if (!used[i]) {
    			   dfs(i);
    		   }
    	   }
    	   boolean flag = true;
    	   for (int i = 0; i < a.size() - 1; i++) {
    		   if (h[a.get(i)].contains(a.get(i + 1)) || h[a.get(i + 1)].contains(a.get(i))) {
    			   continue;
    		   }
    		   flag = false;
    		   break;
    	   }
    	   if (flag) {
    		   r = med;
    	   } else {
    		   l = med;
    	   }
       }
       if (r > m) {
    	   out.print(-1);
       } else {
    	   out.print(r);
       }
    }
    
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new I().run();
    }

}
