import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Locale;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class B {
    public void solve() throws IOException {
    	int n = nextInt();
    	@SuppressWarnings("unchecked")
		PriorityQueue<Car>[] c = new PriorityQueue[4];
    	int[] ans = new int[n];
    	Arrays.fill(ans, -1);
    	for (int i = 0; i < c.length; i++) {
			c[i] = new PriorityQueue<>();
		}
    	for (int i = 0; i < n; i++) {
			int a = nextInt();
			int k;
			switch (nextToken().charAt(0)) {
			case 'U':
				k = 0;
				break;
			case 'R':
				k = 1;
				break;
			case 'D':
				k = 2;
				break;
			default:
				k = 3;
				break;
			}
			c[k].add(new Car(a, i));
		}
    	int t = 0;
    	while (true) {
    		int a = 0;
    		int m = t;
    		for (int i = 0; i < c.length; i++) {
				if (!c[i].isEmpty()) {
					a += c[i].peek().t > t ? 0 : 1;
					m = Math.min(m, c[i].peek().t);
				}
			}
    		if (a == c.length) {
    			break;
    		}
    		a = 0;
    		for (int i = 0; i < c.length; i++) {
				a += c[i].isEmpty() ? 1 : 0;
			}
    		if (a == c.length) {
    			break;
    		}
    		if (m > t) {
    			t = m;
    			continue;
    		}
    		for (int i = 0; i < c.length; i++) {
				if (canGo(c, t, i)) {
					ans[c[i].peek().n] = t;
				}
			}
    		for (int i = 0; i < c.length; i++) {
				if (hasCar(c[i], t) && ans[c[i].peek().n] == t) {
					c[i].poll();
				}
			}
        	t++;
    	}
    	for (int i = 0; i < n; i++) {
    		out.println(ans[i]);
    	}
    }
    
    public boolean hasCar(PriorityQueue<Car> q, int t) {
    	return !q.isEmpty() && q.peek().t <= t;
    }
    
    public boolean canGo(PriorityQueue<Car>[] c, int t, int i) {
    	return hasCar(c[i], t) && !hasCar(c[(i + c.length - 1) % c.length], t);
    }
    
    public class Car implements Comparable<Car> {
    	public final int t, n;

		public Car(int t, int n) {
			this.t = t;
			this.n = n;
		}

		@Override
		public int compareTo(Car o) {
			return Integer.compare(t, o.t);
		}
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
/*
4
0 R
0 U
0 L
5 D

7
0 U
0 D
1 L
1 D
2 D
2 R
2 U
*/