import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class I {
	public void solve() throws IOException {
		int n = nextInt(), m = nextInt();
		ArrayList<Integer> first = new ArrayList<>();
		ArrayList<Integer> second = new ArrayList<>();
		for (int i = 0; i < m; i++) {
			first.add(nextInt() - 1);
			second.add(nextInt() - 1);
		}
		int l = 0, r = m + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (isEnough(first, second, n, mid)) {
				r = mid;
			} else {
				l = mid;
			}
		}
		out.println(r == m + 1 ? -1 : r);
	}
	
	public boolean isEnough(ArrayList<Integer> first, ArrayList<Integer> second, int n, int mid) {
		TreeMap<Integer, TreeSet<Integer>> lines = new TreeMap<>();
		int[] a = new int[n];
		boolean[] f = new boolean[n];
		int z = n;
		for (int i = 0; i < n; i++) {
			lines.put(i, new TreeSet<>());
		}
		for (int i = 0; i < mid; i++) {
			lines.get(first.get(i)).add(second.get(i));
			z -= a[second.get(i)] == 0 ? 1 : 0;
			a[second.get(i)]++;
		}
		for (int k = 1; k < n; k++) {
			if (z > 1) {
				return false;
			}
			z--;
			for (int i = 0; i < n; i++) {
				if (a[i] != 0 || f[i]) {
					continue;
				}
				f[i] = true;
				for (int j : lines.get(i)) {
					a[j]--;
					z += a[j] == 0 ? 1 : 0;
				}
				break;
			}
		}
		return true;
	}
	
	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new I().run();
	}

}

/*
5 5
5 1
3 2
2 4
4 5
3 5

*/