import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class JJ {
	public void solve() throws IOException {
		nextInt();
		String stogsena = nextToken() + " " + nextToken();
		while (true) {
			int pf = pf(stogsena);
			if (pf == 0) {
				out.print("No");
				return;
			} else {
				stogsena = stogsena.substring(0 + pf, stogsena.length() - pf);
				if (stogsena.equals(" ")) {
					break;
				}
			}
		}
		System.out.println("Yes");
	}

	public int pf(String s) {
		int n = s.length();
		int[] p = new int[n + 1];
		p[0] = -1;
		for (int i = 0; i < n; i++) {
			int k = p[i];
			char c = s.charAt(i);
			while ((k >= 0) && (s.charAt(k) != c)) {
				k = p[k];
			}
			p[i + 1] = k + 1;
		}
		return p[n];
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new JJ().run();
	}

}
