import java.io.*;
import java.util.*;

public class Template {
    private String fileName = "a";

    private List<ArrayDeque<Trio>> queues;
    private int[] ans;
    private int time = 0;

    public void solve() throws IOException {
        int n = nextInt();
        List<Trio> list = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            list.add(new Trio(nextInt(), nextToken().charAt(0), i));
        }
        ans = new int[n];
        Arrays.fill(ans, -1);

        queues = new ArrayList<>();
        for (int i = 0; i < 4; i++) {
            queues.add(new ArrayDeque<>());
        }

        for (int i = 0; i < list.size(); i++) {
            Trio curr = list.get(i);
            time = curr.t;
            queues.get(curr.d).addFirst(curr);
            while (i + 1 < list.size() && list.get(i + 1).t == curr.t) {
                queues.get(list.get(i + 1).d).addFirst(list.get(i + 1));
                i++;
            }

//            print();

            while (!isEmpty() && i + 1 < list.size() && time < list.get(i + 1).t) {
                int temp = getSize();
                getLow();
                if (temp == getSize())
                    break;
            }

//            print();
        }

        while (!isEmpty()) {
            int temp = getSize();
            getLow();
            if (temp == getSize())
                break;
        }

        for (int an : ans) {
            out.println(an);
        }
    }

    private void print() {
        for (int j = 0; j < queues.size(); j++) {
            System.out.println(queues.get(j));
        }
        System.out.println();
    }

    private int getSize() {
        int result = 0;

        for (ArrayDeque<Trio> queue : queues) {
            result += queue.size();
        }

        return result;
    }

    private boolean isEmpty() {
        return queues.get(0).isEmpty() &&
                queues.get(1).isEmpty() &&
                queues.get(2).isEmpty() &&
                queues.get(3).isEmpty();
    }

    private void getLow() {
        for (int j = 0; j < queues.size(); j++) {
            if (!queues.get(j).isEmpty() && queues.get(nx(j)).isEmpty()) {
                ans[queues.get(j).getLast().n] = time;
                queues.get(j).pollLast();

                j = nx(nx(j));
                if (!queues.get(j).isEmpty() && queues.get(nx(j)).isEmpty()) {
                    ans[queues.get(j).getLast().n] = time;
                    queues.get(j).pollLast();
                }
                break;
            }
        }
        time++;
    }

    private int nx(int i) {
        return (i + 1) % 4;
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader(fileName + ".in"));
            out = new PrintWriter(fileName + ".out");

//            br = new BufferedReader(new InputStreamReader(System.in));
//            out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Template().run();
    }

}

class Trio {
    int t;
    int d;
    int n;

    public Trio(int t, int d, int n) {
        this.t = t;
        this.d = d;
        this.n = n;
    }

    public Trio(int t, char d, int n) {
        this.t = t;
        switch (d) {
            case 'D':
                this.d = 0;
                break;
            case 'R':
                this.d = 1;
                break;
            case 'U':
                this.d = 2;
                break;
            case 'L':
                this.d = 3;
                break;
        }
        this.n = n;
    }

    @Override
    public String toString() {
        return "Trio{" +
                "t=" + t +
                ", d=" + d +
                ", n=" + n +
                '}';
    }
}