import java.io.*;
import java.util.*;

public class Template {
    private String fileName = "a";

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        Dsu dsu = new Dsu(n);
        for (int i = 0; i < m; i++) {
            int l = nextInt();
            int r = nextInt();
            
            dsu.unite(l, r);
            if (dsu.getCount() == 1) {
                out.println(i + 1);
                return;
            }
        }

        out.print(1);
    }

    public void run() {
        try {
//            br = new BufferedReader(new FileReader(fileName + ".in"));
//            out = new PrintWriter(fileName + ".out");

            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Template().run();
    }

}

class Dsu {
    int[] p;
    int[] r;
    int count;

    public Dsu(int n) {
        p = new int[n];
        for (int i = 0; i < p.length; i++)
            p[i] = i;
        r = new int[n];
        for (int i = 0; i < p.length; i++)
            r[i] = 0;
        count = n;
    }

    private int getR(int a) {
        if (a != p[a])
            p[a] = getR(p[a]);
        return p[a];
    }

    public int getCount() {
        return count;
    }

    public void unite(int a, int b) {
        count--;
        int r1 = getR(a);
        int r2 = getR(b);

        if (r[r2] < r[r1]) {
            int c = r1;
            r1 = r2;
            r2 = c;
        }

        p[r1] = r2;
        if (r[r1] == r[r2])
            r[r1]++;
    }

    public boolean inOne(int a, int b) {
        return getR(a) == getR(b);
    }
}