import java.io.*;
import java.util.*;

public class Template {
    private String fileName = "a";

    private long[] hs;
    private long[] ht;
    private long[] pow;

    private long m = 1_000_000_007;
    private long p;

    public void solve() throws IOException {
        int n = nextInt();
        String s = nextToken();
        String t = nextToken();

        Random r = new Random();
        p = 30 + r.nextInt((int) m - 60);

        hs = new long[s.length() + 1];
        ht = new long[t.length() + 1];

        hs[0] = 0;
        for (int i = 1; i < hs.length; i++)
            hs[i] = (hs[i - 1] * p + s.charAt(i - 1)) % m;

        ht[0] = 0;
        for (int i = 1; i < ht.length; i++)
            ht[i] = (ht[i - 1] * p + t.charAt(i - 1)) % m;

        pow = new long[s.length() + 1];
        pow[0] = 1;
        for (int i = 1; i < pow.length; i++)
            pow[i] = (pow[i - 1] * p) % m;

        out.println((func(0, t.length())) ? "YES" : "NO");
    }

    private boolean func(int l, int r) {
        int maxInd = -1;
//        System.out.println("l = " + l + " r = " + r);
        for (int i = 1; l + i < hs.length; i++) {
//            System.out.println(i);
//            if (hashS(l, l + i) == hashT(r - i, r))
            if (eql(l, l + i, r - i, r))
                maxInd = i;
        }

        if (maxInd == -1)
            return false;
        else if (l + maxInd == hs.length - 1)
            return true;
        else
            return func(l + maxInd, r - maxInd);
    }

    private long hashS(int l, int r) {
        long hash = (hs[r] - hs[l] * pow[r - l]) % m;
        return hash > 0 ? hash : hash + m;
    }

    private boolean eql(int ls, int rs, int lt, int rt) {
        return ((hs[rs] - hs[ls] * pow[rs - ls]) - (ht[rt] - ht[lt] * pow[rt - lt])) % m == 0;
    }

    private long hashT(int l, int r) {
        long hash = (ht[r] - ht[l] * pow[r - l]) % m;
        return hash > 0 ? hash : hash + m;
    }

    public void run() {
        try {
//            br = new BufferedReader(new FileReader(fileName + ".in"));
//            out = new PrintWriter(fileName + ".out");

            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Template().run();
    }

}

class Trio {
    int t;
    int d;
    int n;

    public Trio(int t, int d, int n) {
        this.t = t;
        this.d = d;
        this.n = n;
    }

    public Trio(int t, char d, int n) {
        this.t = t;
        switch (d) {
            case 'D':
                this.d = 0;
                break;
            case 'R':
                this.d = 1;
                break;
            case 'U':
                this.d = 2;
                break;
            case 'L':
                this.d = 3;
                break;
        }
        this.n = n;
    }

    @Override
    public String toString() {
        return "Trio{" +
                "t=" + t +
                ", d=" + d +
                ", n=" + n +
                '}';
    }
}