import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class I {
	String fileName = "i";

	public static class Pair {
		int v;
		int c;

		public Pair(int v, int c) {
			super();
			this.v = v;
			this.c = c;
		}

		@Override
		public String toString() {
			return "(" + v + ", " + c + ")";
		}
		
		

	}

	public static void topsort(int v, int[] col, ArrayList<ArrayList<Pair>> g, ArrayList<Integer> topsort) {
		col[v] = 0;
		for (Pair e : g.get(v)) {
			if (col[e.v] == -1) {
				topsort(e.v, col, g, topsort);
			}
		}
		col[v] = 1;
		topsort.add(v);
	}

	public void solve() throws IOException {

		int n = nextInt(), m = nextInt();
		ArrayList<ArrayList<Pair>> g = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			g.add(new ArrayList<>());
		}

		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			g.get(x).add(new Pair(y, i + 1));
		}

		int[] col = new int[n];
		Arrays.fill(col, -1);

		ArrayList<Integer> preTopSort = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			if (col[i] == -1) {
				topsort(i, col, g, preTopSort);
			}
		}
		
		boolean res = true;
		for (int i = 0; i < n - 1; i++) {
			int x = preTopSort.get(i);
			int y = preTopSort.get(i + 1);
			boolean r1 = false;
			for (Pair e : g.get(y)) {
				if (e.v == x) {
					r1 = true;
				}
			}
			if (!r1) {
				res = false;
			}
		}
		
		if (!res) {
			System.out.println(-1);
			System.exit(0);
		}
		
		int max = -1;
		for (int i = 0; i < n - 1; i++) {
			int x = preTopSort.get(i);
			int y = preTopSort.get(i + 1);
			for (Pair e : g.get(y)) {
				if (e.v == x) {
					int w = e.c;
					if (w > max) {
						max = w;
					}
				}
			}
		}
		
		System.out.println(max);

	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
//			 out = new PrintWriter(fileName + ".out");

			solve();

//			 out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new I().run();
	}

}
