import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class TaskE {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        long k = nextLong();
        long[] s = new long[n];
        for (int i = 0; i < n; i++) {
            s[i] = nextLong();
        }

        Arrays.sort(s);
        long last = s[n - 1];
        long result = (last + k) * n;
        for (int i = n - 2; i > -1; i--) {
            long add = (long)(i + 1) *(long) (last - s[i]) - (long)k *(long) (n - i - 1);
            if (add > 0) {
                last = s[i];
                result -= add;
            }
        }

        out.println(result);
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskE().run();
    }

}
