import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class TaskG {
    String fileName = "";

    public void solve() throws IOException {
        int nf = nextInt(), mf = nextInt();
        int[] min = new int[mf];
        Arrays.fill(min, Integer.MIN_VALUE / 3);
        boolean[][] table = new boolean[nf][mf];
        for (int i = 0; i < nf; i++) {
            char[] s = nextToken().toCharArray();
            for (int j = 0; j < mf; j++) {
                table[i][j] = s[j] == '*';
                if (table[i][j]) {
                    min[j] = i;
                }
            }
        }

        int n0 = nextInt(), m0 = nextInt();
        int[] max = new int[m0];
        Arrays.fill(max, Integer.MAX_VALUE / 3);
        boolean[][] shape = new boolean[n0][m0];
        for (int i = 0; i < n0; i++) {
            char[] s = nextToken().toCharArray();
            for (int j = 0; j < m0; j++) {
                shape[i][j] = s[j] == '#';
                if (max[j] == Integer.MAX_VALUE / 3 && shape[i][j]) {
                    max[j] = nf + i;
                }
            }
        }

        int res = 0;
        for (int i = -mf + 1; i < m0; i++) {
            int d = Integer.MAX_VALUE;
            for (int t = 0; t < m0; t++) {
                if (t - i >= 0 && t - i < mf) {
                    d = Math.min(d, max[t] - min[t - i] - 1);
                }
            }
            int count = 0;
            for (int x = nf; x < n0 + nf; x++) {
                for (int y = 0; y < m0; y++) {
                    if (x - d >= 0 && x - d < nf && y - i + 1 >= 0 && y - i + 1 < mf &&
                            shape[x - nf][y] && table[x - d][y - i + 1]) {
                        count++;
                    }
                }
            }
            res = Math.max(res, count);
        }

        out.println(res);
    }

/*
5 6
******
*.*.*.
*.*.*.
*.....
*.....
3 8
#.#.#.#.
#.#.#.#.
#######.


3 2
**
.*
.*
2 1
#
#


3 3
...
.*.
...
3 3
#..
##.
...


2 3
.**
..*
2 5
.#.#.
.####
 */

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskG().run();
    }

}
